# SEARX Crawler

## Base website
https://searx.me/
## Based on
https://gitlab.iscpif.fr/smurail/gargantext-light/blob/simon-gargantext-light/gargantext/scrapers/searx.py

## Usage
### Entry function
The basic entry point of this crawler is the function `SEARX.` `getMetadataWith`.

This function take a `Text` representing the query you want to run on searx
and a `Int` representing the maximum number of pages you want to get.
### Return Type
The return type is pretty simple, it's **either** a `ClientError` or a `ISTEX.` `Client.Documents`.

`Documents` represent a collection of `ISTEX.` `Client.Document` and the number of `Document` returned.

`Document` is a simple type that contain nearly every informations we need (id,title,abstract,publicationDate,sources).

**authors** is not present since it's not contained in the searx database.
### Exemple
Here is a basic main using the entry point of the crawler and printing the 5 first results.
```hs
{-# LANGUAGE OverloadedStrings #-}

module Main where

import SEARX

main :: IO ()
main = do
  res <- getMetadataWith "ia" 300
  case res of
    (Left err) -> print err
    (Right r) -> print $ take 5 $ _documents_hits r

```
 
